package com.tmax.openframe.file;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dataset.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.dataobject.exception.EmptyResultException;
import com.tmax.proobject.dataobject.session.SessionContainer;
import java.math.*;
import java.sql.SQLException;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class COBTEST5_FD_IN_F {
    private static final int DEFAULT_FETCH_SIZE = 100;
    private COBTEST5_COBTEST5_FD_IN_F_Dof dof;
    private @Getter FileStatus fileStatus;
    private Iterator<COBTEST5_COBTEST5_FD_IN_F_Do> forwardListIterator_COBTEST5_FD_IN_F;

    public COBTEST5_FD_IN_F() {
        dof = new COBTEST5_COBTEST5_FD_IN_F_Dof("tibero6_dev");
        forwardListIterator_COBTEST5_FD_IN_F = null;
    }

    public void start(COBTEST5_DL_KEY key, KeyOperationType type) {
        switch (type) {
        case KeyOperationType.EQ: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_EQ);
            break;
        }
        case KeyOperationType.GT: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_GT);
            break;
        }
        case KeyOperationType.GTEQ: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_GE);
            break;
        }
        case KeyOperationType.LT: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_LT);
            break;
        }
        }
        dof.setField("DL_CONT_NO", key.getDL_CONT_NO());
        dof.setField("DL_IITEM", key.getDL_IITEM());
        dof.setField("DL_IITEM_GB", key.getDL_IITEM_GB());
        forwardListIterator_COBTEST5_FD_IN_F = dof.getForwardList().iterator();
        if (forwardListIterator_COBTEST5_FD_IN_F.hasNext()) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return;
        }
        fileStatus = FileStatus.NORMAL;
    }

    public COBTEST5_EMDAIYC read() {
        if (forwardListIterator_COBTEST5_FD_IN_F != null
                && forwardListIterator_COBTEST5_FD_IN_F.hasNext()) {
            return forwardListIterator_COBTEST5_FD_IN_F.next();
        } else {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_EQ);
            dof.setFetchSize(DEFAULT_FETCH_SIZE);
            forwardListIterator_COBTEST5_FD_IN_F = dof.getForwardList()
                    .iterator();
            if (forwardListIterator_COBTEST5_FD_IN_F.hasNext()) {
                return forwardListIterator_COBTEST5_FD_IN_F.next();
            }
        }
        return null;
    }

    public COBTEST5_EMDAIYC readNext() {
        return read();
    }

    public COBTEST5_EMDAIYC readKey(COBTEST5_DL_KEY key, KeyOperationType type) {
        switch (type) {
        case KeyOperationType.EQ: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_EQ);
            break;
        }
        case KeyOperationType.GT: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_GT);
            break;
        }
        case KeyOperationType.GTEQ: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_GE);
            break;
        }
        case KeyOperationType.LT: {
            dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.READ_LT);
            break;
        }
        }
        dof.setField("DL_CONT_NO", key.getDL_CONT_NO());
        dof.setField("DL_IITEM", key.getDL_IITEM());
        dof.setField("DL_IITEM_GB", key.getDL_IITEM_GB());
        forwardListIterator_COBTEST5_FD_IN_F = dof.getForwardList().iterator();
        COBTEST5_EMDAIYC record = read();
        if (record == null) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return null;
        }
        return record;
    }

    public void rewrite(COBTEST5_EMDAIYC data) {
        COBTEST5_COBTEST5_FD_IN_F_Do tmpObject = COBTEST5_COBTEST5_FD_IN_F_DoToCOBTEST5_EMDAIYCMapper.INSTANCE
                .toCOBTEST5_COBTEST5_FD_IN_F_Do(data);
        dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.REWRITE);
        try {
            dof.update(tmpObject);
            fileStatus = FileStatus.NORMAL;
        } catch (EmptyResultException ex) {
            fileStatus = FileStatus.INVALID_KEY_CREATE;
        }
    }

    public void write(COBTEST5_EMDAIYC data) {
        dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.WRITE);
        dof.add(COBTEST5_COBTEST5_FD_IN_F_DoToCOBTEST5_EMDAIYCMapper.INSTANCE
                .toCOBTEST5_COBTEST5_FD_IN_F_Do(data));
        fileStatus = FileStatus.NORMAL;
    }

    public int delete(COBTEST5_DL_KEY key) {
        dof.setFullQuery(COBTEST5_COBTEST5_FD_IN_F_Dof.FULLQUERY.DELETE);
        dof.setField("DL_CONT_NO", key.getDL_CONT_NO());
        dof.setField("DL_IITEM", key.getDL_IITEM());
        dof.setField("DL_IITEM_GB", key.getDL_IITEM_GB());
        int cnt = dof.remove();
        if (cnt == 0) {
            fileStatus = FileStatus.INVALID_KEY_READ;
        } else {
            fileStatus = FileStatus.NORMAL;
        }
        return cnt;
    }

    public void close() {
        SessionContainer.getInstance().commit();
        forwardListIterator_COBTEST5_FD_IN_F = null;
    }
}
